// Aktywna bariera podczerwienie ze zmiennym kodem
// Zbigniew Hajduk, 2004

#include <reg51.h>
#include <stdlib.h>
typedef unsigned char uchar;

sbit in=P3^2;

sbit LED1=P1^6;
sbit LED2=P1^4;
sbit LED3=P1^1;
sbit LED4=P1^0;

sbit RELAY1=P1^7;
sbit RELAY2=P1^5;
sbit RELAY3=P1^3;
sbit RELAY4=P1^2;

sbit LED=P3^4;
sbit SW=P3^5;

void delay(unsigned int);

char cntbit;
bit p_in,c_in,rdy;
volatile int cnt;
char errcnt;


char rand_table[32];

bit pgm,Toggle,mToggle,flash,flash1;
char cmd,addr;
char pcnt,tcnt;
bit sw,msw,sw1,ac1;
int irdata;
int alarm_cnt;
bit fp,sync;
char lcnt;

void main(void)
{
   bit alarm;
   char seed,cntr,mcmd;
   char i;


      TMOD=0x11; TR0=1; TR1=1;
      TL0=0; TH0=0;
      IP=1; ET0=0; ET1=1; EX0=1; EA=1;  IT0=1;

      LED1=LED2=LED3=LED4=1;
      RELAY1=RELAY2=RELAY3=RELAY4=0;
      LED=SW=1;
      pgm=0;   flash=0; flash1=0;
      tcnt=0;  sw1=0;  ac1=0; fp=0;

      sync=0; alarm=0; errcnt=0; lcnt=0;

     while(1)
     {
         if(!sync) flash1=1;
         else LED=0;

        if(sync&&cnt>30)
        {
          sync=0; alarm=1;
        }


        if(alarm&&LED1)
        {
           LED1=0; RELAY1=1;  alarm_cnt=0;
        }

        if(alarm&&!sync) alarm_cnt=0;

        if(alarm_cnt>40)
        {
          if(alarm) { alarm=0; LED1=1; RELAY1=0; alarm_cnt=0; }
        }

        if(sw)
        {
           sw=0;
           if(alarm)
           {  alarm=0; LED1=1; RELAY1=0;
           }
        }



       if(rdy)
       {
         rdy=0;   lcnt=0; LED2=0;

         if(Toggle)
         {  seed=irdata;
            cntr=0;  alarm_cnt++;
            srand(seed);
            for(i=0;i<31;i++) rand_table[i]=rand()&0x3f;
            sync=1;
            cnt=0;   errcnt=0;
         }
         else
         {   cntr++;
             mcmd=rand_table[cntr-1];
            if(sync)
            {

               if(addr!=cntr||cmd!=mcmd)
               {
                   if(cmd==rand_table[addr-1])
                   {
                    if(addr==(cntr-1)||addr==(cntr+1)||addr==(cntr-2)||addr==(cntr+2))
                    {
                       cntr=addr; errcnt=0; cnt=0;
                    }
                   }
                  else
                  {
                   errcnt++;
                   if(errcnt>3)
                   { sync=0; alarm=1;
                   }
                  }
               }
               else { cnt=0; errcnt=0; }
            }
         }

       }

     }

}  /*End of main */



void delay(unsigned int a)
{
   while (a--);
}


void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char p_th,state;

   TL0=0; TH0=0; tmp=0; cntbit=0; state=0;


   while(1)
   {
     p_in=in;
     while(p_in==in) if (TH0>8)  return;
     p_th=TH0; TL0=0; TH0=0; c_in=in;

     switch(state)
     {
       case 0:
            if(!p_in&&c_in&&p_th>2&&p_th<5) state=1;
            else
            if(!p_in&&c_in&&p_th>4&&p_th<8)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;
       case 1:
            if(p_in&&!c_in&&p_th>2&&p_th<5)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else  return;
            break;
       case 2:
            if(p_in&&!c_in&&p_th>4&&p_th<8)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else
            if(p_in&&!c_in&&p_th>2&&p_th<5) state=3;
            else return;
            break;
       case 3:
            if(!p_in&&c_in&&p_th>2&&p_th<5)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;

     }
     if(cntbit>=13)
     {
     irdata=tmp;
     cmd=tmp&0x003f; addr=(tmp>>6)&0x001f;
     Toggle=(tmp&0x0800)?1:0;
     rdy=1; TL0=1; TH0=1; fp=0; return;
     }

   }

}


void int_t0(void) interrupt 1 using 2
{

}


void int_t1(void) interrupt 3 using 2
{
   TH1=216; TL1=241; //10ms
   cnt++;
   tcnt++;
   lcnt++;

   if(!SW&&msw) sw=1;
   msw=SW;

   if(tcnt>20)
   {  tcnt=0;

      if(flash1) LED=!LED;
   }
   if(lcnt>10)
   { lcnt=0;
     if(!LED2) LED2=1;
   }
   

}





