//Konwerter NEC - RC5
//Autor: Zbigniew Hajduk, 2004

#include <reg51.h>
typedef unsigned char uchar;


sbit in=P3^2;
sbit LED=P3^4;
sbit out=P1^7;

void rc5tx(int);
void delay(unsigned int);
static unsigned int reverse2(unsigned int);


unsigned int irdata1,irdata2;
char cntbit;
bit p_in,c_in,rdy;
int cnt;
bit Toggle,mT;


void main(void)
{  char cmd,addr,m_cmd,f;
   unsigned rc5code;


      TMOD=0x11; TR0=1; TR1=1;
      TL0=0; TH0=0;
      IP=1; IE=0x8b;  IT0=1;


     out=0;
     LED=0; delay(40000); LED=1;
     mT=0; m_cmd=255;


     while(1)
     {
       if(rdy)
       {
         rdy=0; LED=0;

          irdata1=reverse2(irdata1); irdata2=reverse2(irdata2);
          addr=irdata2>>8; cmd=irdata1>>8;


         if(irdata2!=0x866b) { LED=1; continue; }

         if(m_cmd==cmd) mT=!mT;

         m_cmd=cmd;   f=1;

         switch (cmd)
         {   case 0x01: rc5code=0x3581; break;
             case 0x0b: rc5code=0x3582; break;
             case 0x1b: rc5code=0x3583; break;
             case 0x05: rc5code=0x3584; break;
             case 0x09: rc5code=0x3585; break;
             case 0x15: rc5code=0x3586; break;
             case 0x06: rc5code=0x3587; break;
             case 0x0a: rc5code=0x3588; break;
             case 0x12: rc5code=0x3589; break;
             case 0x02: rc5code=0x3580; break;
             case 0x1e: rc5code=0x358c; break;
             case 0x16: rc5code=0x35a0; break;
             case 0x14: rc5code=0x35a1; break;
             case 0x0c: rc5code=0x35ba; break;
             case 0x04: rc5code=0x35b9; break;
             case 0x0e: rc5code=0x35bb; break;
             case 0x0f: rc5code=0x35a3; break;
             case 0x0d: rc5code=0x358f; break;
             default: f=0;

         }
         if(f)
         {
          rc5code|=(mT)?0x0800:0;
          rc5tx(rc5code);
         }


         LED=1;


       }

     }



}  



void delay(unsigned int a)
{
   while (a--);
}


void int_t0(void) interrupt 1 using 2
{

}

void int_t1(void) interrupt 3 using 2
{

}

void int_ext0(void) interrupt 0 using 2
{
   unsigned long int tmp;
   char i,lp;
   bit m_in;


   TH0=0; TL0=0;
   tmp=0;
   while (!in)
    if(TH0>47) return; //t>12ms

   if(TH0<27) return; //t<7ms

   TH0=0; TL0=0;
   while (in)
    if(TH0>24) return; //t>6.1ms
   if(TH0<15) return; //t<3.8ms
   i=0;
   while(1)
   {   TH0=0; TL0=0;
       m_in=in;
       while(1)
       {  if(TH0>12) return; //t>3ms
          if(m_in!=in)
            if(m_in&&!in) break; //zbocze opadajace
            else
            m_in=in;
       }
       if(TH0>=7) tmp|=1;
       i++;
       if(i>31)
       {
          irdata1=tmp; irdata2=tmp>>16;
          rdy=1;
          return;
       }
       tmp<<=1;
   }

}

static unsigned int reverse2(unsigned int x)
{  code char xchg[16]={0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15};
   uchar t,w1,w2;


   t=x; w1=xchg[t&0x0f]; w1<<=4; w1|=xchg[t>>4];
   t=x>>8; w2=xchg[t&0x0f]; w2<<=4; w2|=xchg[t>>4];
   x=w2; x<<=8; x|=w1;
   return x;

}

