// Konwerter RC5 - ITT
// Autor: Zbigniew Hajduk

#include <reg51.h>
typedef unsigned char uchar;

#define RC5ADDR 0

sbit in=P3^2;
sbit out=P3^5;
sbit power=P1^7;
sbit agc_off=P1^4;

void ittgen(int);

void BusyCheck(void);
void LCDSendByte(uchar,bit);
void LCDinit (void);
void clrscr (void);
void gotoxy (uchar,uchar);
void LCDputs (char*);
void LCDputch(char);
void delay(unsigned int);
void moveCGRAM (uchar,char,char);


static void printhex(uchar i,bit f);

unsigned int irdata;
char cntbit;
bit p_in,c_in,rdy;
int cnt;

bit agcoffbit;
bit T,Tm,Tf;

void main(void)
{  char cmd,addr;
   int ittdata;

      TMOD=0x11; TR0=1; TR1=1;
      TL0=0; TH0=0;
      IP=1; IE=0x8b;  IT0=1;


     out=0;  power=0; cnt=0;
     agc_off=0; agcoffbit=0;
     Tf=0;

   
     while(1)
     {
       if(rdy)
       {
         rdy=0;

         cmd=irdata&0x003f; addr=(irdata>>6)&0x001f;
         T=(irdata&0x0800)?1:0;
         if(!Tf) Tm=!T;
         Tf=1;

         if(addr!=RC5ADDR) continue;
 
         switch (cmd)
         {  case 1: ittdata=0x02; break;
            case 2: ittdata=0x22; break;
            case 3: ittdata=0x12; break;
            case 4: ittdata=0x32; break;
            case 5: ittdata=0x0a; break;
            case 6: ittdata=0x2a; break;
            case 7: ittdata=0x1a; break;
            case 8: ittdata=0x3a; break;
            case 9: ittdata=0x06; break;
            case 0: ittdata=0x26; break;
            case 0x2e: ittdata=0x04; break;
            case 0x2d: ittdata=0x38; break;
            case 0x0a: ittdata=0x28; break;
            case 0x21: ittdata=0x08; break;
            case 0x0e: ittdata=0x30; break;
            case 0x35: ittdata=0x05; break;
            case 0x2a: ittdata=0x25; break;
            case 0x29: ittdata=0x15; break;
            case 0x2b: ittdata=0x35; break;
            case 0x20: ittdata=0x0d; break;
            case 0x2c: ittdata=0x2d; break;
            case 0x37: ittdata=0x19; break;
            case 0x0c: ittdata=0x20; power=0; break;
         }

          if(T==Tm) ittdata|=0x0f00;


          ittgen(ittdata);
          ittdata|=0x0f00;

          agc_off=1;
          Tm=T;

         delay(3000);
         ittgen(ittdata);

                 if(cmd>0&&cmd<10)
                 { power=1; cnt=0; agc_off=1; agcoffbit=1;
                 }

                if(cmd==0x28||cmd==0x08)
                {
                 cnt=0; agc_off=1; agcoffbit=1;
                }

       }

     }


} 



void delay(unsigned int a)
{
   while (a--);
}



void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char p_th,state;

   TL0=0; TH0=0; tmp=0; cntbit=0; state=0;

   while(1)
   {
     p_in=in;
     while(p_in==in) if (TH0>8) return;
     p_th=TH0; TL0=0; TH0=0; c_in=in;

     switch(state)
     {
       case 0:
            if(!p_in&&c_in&&p_th>2&&p_th<5) state=1;
            else
            if(!p_in&&c_in&&p_th>4&&p_th<8)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;
       case 1:
            if(p_in&&!c_in&&p_th>2&&p_th<5)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else return;
            break;
       case 2:
            if(p_in&&!c_in&&p_th>4&&p_th<8)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else
            if(p_in&&!c_in&&p_th>2&&p_th<5) state=3;
            else return;
            break;
       case 3:
            if(!p_in&&c_in&&p_th>2&&p_th<5)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;

     }
     if(cntbit>=13) { irdata=tmp; rdy=1; return; }

   }

}


void int_t0(void) interrupt 1 using 2
{

}

void int_t1(void) interrupt 3 using 2
{
   TH1=0xf6; TL1=0x3b;
   cnt++;
   if(agcoffbit)
   {
      if(cnt>200)
      {   agc_off=0;
           cnt=0; agcoffbit=0;
      }

   }

}