//Konwerter danych RC5 - RS232
// Zbigniwe Hajduk, 2004

#include <reg51.h>
typedef unsigned char uchar;


sbit in=P3^2;
sbit LED=P3^4;
sbit out=P1^7;


void delay(unsigned int);
void rc5tx(int);
char hex2dec(char *);
void rs_puts(char *);
void rs_putch(char);
static void rs_printhex(uchar);


unsigned int irdata;
char cntbit;
bit p_in,c_in,rdy;
int cnt;
bit err_display;
char err;

char buf[12];
int tcnt;
bit rx_sta;

void main(void)
{  char cmd,addr,i,bcnt;
   bit T;

      TMOD=0x21; TR0=1; TR1=1;
      TH1=0xfd;
      PCON=0x00;
      SCON=0x50;
      TL0=0; TH0=0;
      IP=1;  IT0=1;
      EX0=1; ET0=1;  EA=1;

     out=0;
     err=0;  err_display=0; rx_sta=0;



     while(1)
     {  LED=1;


       if (err&&!err_display)
       {  err_display=1;

       }

       if(rdy)
       {
         rdy=0;  LED=0;
         err_display=0;

         cmd=irdata&0x003f; addr=(irdata>>6)&0x001f;
         T=(irdata&0x0800)?1:0;

         rs_putch(0x0d); delay(200);
         rs_printhex(addr); rs_puts(" ");
         rs_printhex(cmd);
         rs_puts(" "); rs_putch(T?49:48);

         LED=1;

       }
       if(RI)
       {  RI=0;

            i=SBUF;

            if(i==0x0d)
            { rx_sta=1; bcnt=0;
              continue;
            }

          tcnt=0;
          buf[bcnt]=i;
          bcnt++;

          if(bcnt==7)
          { rx_sta=0; LED=0;

            i=hex2dec(&buf[0]);
            if(i==255) continue;
            addr=16*i;
            i=hex2dec(&buf[1]);
            if(i==255) continue;
            addr+=i;

            i=hex2dec(&buf[3]);
            if(i==255) continue;
            cmd=i*16;
            i=hex2dec(&buf[4]);
            if(i==255) continue;
            cmd+=i;

            if(buf[6]=='0') T=0;
            else
            if(buf[6]=='1') T=1;
            else
            continue;

            LED=0;
            irdata=addr&0x1f; irdata<<=6;
            irdata|=cmd&0x3f; irdata|=(T)?0x3800:0x3000;
            rc5tx(irdata);
            LED=1;

          }


       }



     }




}  /*End of main */



void delay(unsigned int a)
{
   while (a--);
}


void int_t0(void) interrupt 1 using 2
{

  //TH0=216; TL0=235;
   tcnt++;
  err=0; err_display=0;

}

void int_t1(void) interrupt 3 using 2
{


}

void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char i,lp;
   bit m_in;

   TL0=49; TH0=251;
   i=0; tmp=0;

   while(1)
   {
      m_in=in;
      lp=0; TF0=0;
      while(!TF0)
         if(in!=m_in)
         {  lp++; m_in=in;
            if(lp>1) { err=1; return; }
         }

      tmp|=in; TF0=0;
      i++;
      if(i==13)  { irdata=tmp; err=0; rdy=1; return; }
      tmp<<=1;

      while(m_in==in)
       if(TH0>4) { err=1; return; }

      TL0=49; TH0=251;

   }

}
void rs_puts(char *p)
{
  while(*p)
  {
    SBUF=*p++;
    while(!TI);
    delay(400);
  }
}

void rs_putch(char x)
{
   SBUF=x;
   while(!TI);
}


static void rs_printhex(uchar i)
{
    char *tohex="0123456789ABCDEF";

    SBUF=tohex[i>>4]; while(!TI); delay(400);
    SBUF=tohex[i&0x0f]; while(!TI); delay(200);
}




char hex2dec(char *p)
{ int i;

   i=*p;
            if(i>='0'&&i<='9') i-='0';
            else
            if(i>='A'&&i<='F') i-='A'+10;
            else
            if(i>='a'&&i<='f') i-='a'+10;
            else i=255;

 return i;
}