//Odbiornik - Dekoder RC5->RS232
//Zbigniew Hajduk, 2004

#include <reg51.h>
typedef unsigned char uchar;

sbit in=P3^2;
sbit LED=P3^4;

void delay(unsigned int);
void int_ext0(void);
void int_t0(void);

void rs_puts(char *);
void rs_putch(char);
static void rs_printhex(uchar);



unsigned int irdata;
bit err_display,rdy;
char err,err_cntr;


void main(void)
{  char cmd,addr,i;
   bit T;

      TMOD=0x21; TR0=1; TR1=1;
      TH1=0xfd;
      PCON=0x00;
      SCON=0x40;
      TL0=0; TH0=0;
      IP=1;  IT0=1;
      EX0=1; ET0=1; EA=1;

      err=0;  err_display=0; rdy=0; err_cntr=0; LED=1;

      rs_putch(0x0c); delay(300);
      rs_puts("Dekoder protokolu RC5, Zbigniew Hajduk 2004");
      for (i=0;i<7;i++)
      {
         LED=0; delay(20000); LED=1; delay(20000);

      }


     while(1)
     {
       if (err_cntr>12&&!err_display)
       {  err_display=1;
          rs_putch(0x0c); delay(300);
          rs_puts("Ten pilot nie pracuje w standardzie RC5!!");
          LED=0; delay(20000); LED=1; delay(20000);
          LED=0; delay(20000); LED=1; delay(20000);
          LED=0; delay(20000); LED=1;
       }

       if(rdy)
       {
         LED=0;
         rdy=0; err_display=0; err_cntr=0;

         cmd=irdata&0x003f; addr=(irdata>>6)&0x001f;
         T=(irdata&0x0800)?1:0;

         rs_putch(0x0c); delay(300);
         rs_puts("Adres RC5="); rs_printhex(addr);
         rs_puts(" Polecenie="); rs_printhex(cmd);
         rs_puts(" T="); rs_putch(T?49:48);
         LED=1;
        }
     }

}


void delay(unsigned int a)
{
   while (a--);
}


void int_t0(void) interrupt 1 using 2
{
   err=0; err_display=0;  err_cntr=0;
}

void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char i,lp;
   bit m_in;

   TL0=49; TH0=251;
   i=0; tmp=0;

   while(1)
   {
      m_in=in;
      lp=0; TF0=0;
      while(!TF0)
         if(in!=m_in)
         {  lp++; m_in=in;
            if(lp>1) { err_cntr++; return; }
         }

      tmp|=in; TF0=0;
      i++;
      if(i==13)  { irdata=tmp; err=0; rdy=1; return; }
      tmp<<=1;

      while(m_in==in)
       if(TH0>4) { err_cntr++; return; }

      TL0=49; TH0=251;

   }

}
void rs_puts(char *p)
{
  while(*p)
  {
    SBUF=*p++;
    while(!TI);
    delay(400);
  }
}

void rs_putch(char x)
{
   SBUF=x;
   while(!TI);
}


static void rs_printhex(uchar i)
{
    char *tohex="0123456789ABCDEF";

    SBUF=tohex[i>>4]; while(!TI); delay(400);
    SBUF=tohex[i&0x0f]; while(!TI); delay(200);
}
