                NAME onewire

iram            segment data

DSbit           BIT     P3.3


onewp           segment code


                public  DSReset
                public  _DSTx
                public  DSRx
                public  _CRCupdate
                public  ResetCRC
                public  GetCRC

                rseg    iram
delay:          ds      1
temp:           ds      1
CRC:            ds      1

                rseg  onewp
Delay5us:
                nop
                nop
                nop
                djnz    delay,Delay5us
                ret

DSReset:
                mov     r5,IE
                anl     IE,#129
                clr     DSbit
                mov     delay,#119
                lcall   Delay5us
                setb    DSbit
                mov     delay,#12
                lcall   Delay5us
                mov     r7,#0
                jnb     DSbit,next1
                mov     r7,#1
next1:
                mov     delay,#60
                lcall   Delay5us
                mov     IE,r5
                ret

_DSTx:
                clr     EA
                mov     r6,#8
                mov     a,r7
Loop1:
                mov     delay,#1
                clr     DSbit
                lcall   Delay5us
                clr     c
                rrc     a
                jnc     next2
                setb    DSbit
next2:
                mov     delay,#14
                lcall   Delay5us
                setb    DSbit
                nop
                djnz    r6,Loop1
                setb     EA
                ret

DSRx:
                mov     r6,#8
                mov     a,#0
                clr     EA
Loop2:
                mov     delay,#1
                clr     DSbit
                call    Delay5us
                setb    DSbit
                nop
                nop
                clr     c
                jnb     DSbit,next3
                setb    c
next3:
                rrc     a
                mov     delay,#11
                lcall   Delay5us
                djnz    r6,Loop2
                mov     r7,a
                setb    EA
                ret


_CRCupdate:
                mov     a,r7
                mov     temp,a
                mov     r6,#8
CRCLoop:
                xrl     a,CRC
                rrc     a
                mov     a,CRC
                jnc     ZERO
                xrl     a,#18h
ZERO:
                rrc     a
                mov     CRC,a
                mov     a,temp
                rr      a
                mov     temp,a
                djnz    r6,CRCLoop
                ret

ResetCRC:
                mov     CRC,#0
                ret
GetCRC:
                mov     r7,CRC
                ret

                end