//Regulator temperatury ze zdalnym sterowaniem
//Autor: Zbigniew Hajduk, 2004

#include <reg51.h>
typedef unsigned char uchar;

//Adres urzadzenia RC5
#define RC5_ADDR 0x00

//Poprawka odczytu temperatury dla termometru DS1820
#define DELTA 0


sbit  dqq=P3^3;
sbit in=P3^2;
sbit A1=P3^0;
sbit A2=P3^1;
sbit A3=P3^4;
sbit A4=P3^5;
sbit pwr=P3^7;

uchar DSReset(void);
void DSTx(uchar);
uchar DSRx(void);
void  CRCupdate(uchar);
void ResetCRC(void);
uchar GetCRC(void);

uchar ReadROM(void);
static uchar DSStartConversion (char*);

void clrscr (void);

void get_temp(void);
char table(char);
void display_temp(void);
void power_up(void);
void setminmax(int *);
void display_auto(void);
void display_error(void);
void clrscr(void);
void display_set(void);
char ReadUserBytes(void);
char WriteScratchpad(void);
static void printhex(uchar,bit);
void delay(unsigned int);

uchar buf[10];
char acnt;
void int_t0(void);
char mh,ml;
bit start_seq, start_bit,rdy,dispbit;
volatile int timeout;
int bitcnt;
char fcnt,addr,cmd;
bit Toggle,mToggle;
char display[4];
code char dev[]={0x10,0x9e,0x86,0x38,0x00,0x00,0x00,0x5a};
int temp;
bit power;
char dcnt,dxx;
int min,max;
int tmin,tmax;
bit am;
int amcnt;
bit da,mda;
bit disp_min,disp_max;

void main(void)
{

        int ct; char r_cnt;

        TMOD=0x11; TR0=1; TR1=1;
        TL0=0; TH0=0;
        IP=1; IE=0x8b;  IT0=1;


        start_seq=0;
        acnt=0;
        A1=A2=A3=A4=1;
        dispbit=0;
        power=1;
        dxx=0; timeout=0;
        disp_min=disp_max=0;
        ET1=0; P1=255;
        am=0;  da=0;
        clrscr();
        tmin=tmax=0;

        EA=0;
        while(1)
        {
         if (!ReadUserBytes()) break;
         acnt++;
         if (acnt>40)
         { acnt=0;
           display_error(); EA=1; ET1=1; delay(30000);
           delay(30000); delay(30000);
         break;
         }
         delay(100);
        }
        ET1=1; EA=1;



        DSStartConversion(dev);
        if(!DSStartConversion(dev))
        { get_temp();
          ct=min=max=temp;
        }

        display_temp();

    rdy=0;
    while(1)
    {

     if(timeout>6500) { pwr=power=1; display[0]=255; timeout=0; }

     if(am&&amcnt>2000)
     { display_auto(); amcnt=0; delay(30000); delay(30000); da=0;
       clrscr();
     }


     if(rdy)
     {
       rdy=0;
       start_seq=0;

       if (addr==RC5_ADDR&&Toggle!=mToggle)
       {


        if(cmd==1&&power)  // 1
        {
         pwr=0; power=0; dcnt=0;
         timeout=0; am=0; da=1;
         power_up();
         clrscr(); temp=ct; display_temp(); da=0;

        }

       if(cmd==2) //2
       {
         power=1; display[0]=255;  disp_min=disp_max=0; am=0;
         pwr=1;  da=0;
       }

       if(cmd==0x39||cmd==0x11)  //Arrow Left
       {
          mda=da; fcnt=0; disp_min=1; disp_max=0; da=1; display[0]|=16+128;
       }

       if(cmd==0x3a||cmd==0x10)  //Arrow Right
       {
         mda=da; fcnt=0; disp_max=1; disp_min=0; da=1; display[0]|=16+128;
       }

         if(cmd==0x3b)  //OK
         {

           if (disp_max) max=ct;
           if (disp_min) min=ct;
           if (disp_min||disp_max)
           {
            display_set(); delay(30000);
            delay(30000); delay(30000); clrscr();
            disp_min=disp_max=0; da=mda;
           }

         }

         if(cmd==0x0c)  //Power
         {
            if (disp_min||disp_max)
            {  disp_min=disp_max=0; da=mda; display[0]|=16+128;
            }

         }


        if(cmd==0x34)  //favorite blue
        {   da=1; display[0]=197; mToggle=Toggle;
            setminmax(&tmin); da=0;
        }

        if(cmd==0x37)  //favorit red
        {    da=1; display[0]=57; mToggle=Toggle;
             setminmax(&tmax); da=0;
        }

        if(cmd==0x20)  //Arrow Up
        {
          am=1;  timeout=0;
          display_auto(); delay(30000); delay(30000); delay(30000);
          da=0; clrscr();
          amcnt=0;

        }

        if(cmd==0x21)  //Arrow Down
        {
          am=0;  power=1; pwr=1; display_set(); delay(30000); delay(30000);
          delay(30000); clrscr();
        }
       }
        mToggle=Toggle;
   }


         if (disp_min) { temp=min; display_temp(); }
         if (disp_max) { temp=max; display_temp(); }

        r_cnt++;
        if(r_cnt>90)
        {
         if(!DSStartConversion(dev))
         {
            get_temp(); ct=temp; r_cnt=0;
            if  (temp<min) min=temp;
            if (temp>max) max=temp;
            if(!(disp_min||disp_max)) display_temp();
         }
         else continue;
        }

        if (am)
        {
           if(ct<tmin&&power)
           { power_up(); clrscr();
             pwr=0; power=0; timeout=0;
           }
           if(ct>tmax&&!power) { pwr=1; power=1; timeout=0; display[0]|=253;}

        }


    }


}


void int_t0(void) interrupt 1 using 2
{

  ET1=1; TR1=1;

  start_bit=start_seq=0;

}


void int_t1(void) interrupt 3 using 2
{
   TH1=0xf6; TL1=0x3b;
   P1=255;
   switch(acnt)
   { case 0: A1=0; A2=1; A3=1; A4=1;
             P1=display[acnt]; acnt=1; break;
     case 1: A1=1; A2=0; A3=1; A4=1;
             P1=display[acnt]; acnt=2; break;
     case 2: A1=1; A2=1; A3=0; A4=1;
             P1=display[acnt]; acnt=3; break;
     case 3: A1=1; A2=1; A3=1; A4=0;
             P1=display[acnt]; acnt=0; break;
   }
   dispbit=1;
   dxx++;         amcnt++;
   if (disp_min||disp_max)
   {  da=1;
      if (!(amcnt%100))
      {
         if (disp_max)
         { if(display[0]&128) display[0]&=255-128; else display[0]|=128; }
         else
         { if(display[0]&16) display[0]&=255-16; else display[0]|=16; }
         fcnt++;

      }
      if (fcnt>40) { disp_min=disp_max=0; display[0]|=16+128; da=mda;}

   }  else fcnt=0;


   if(dxx>50&&!power)
   { dxx=0;
      timeout++;
      if (da) return;
      switch(dcnt)
      {
       case 0: display[0]=255-32; dcnt=1; break;
       case 1: display[0]=255-64; dcnt=2; break;
       case 2: display[0]=255-128; dcnt=3; break;
       case 3: display[0]=255-4; dcnt=4; break;
       case 4: display[0]=255-8; dcnt=5; break;
       case 5: display[0]=255-16; dcnt=0; break;
      }

   }


}


void delay(unsigned int a)
{
   while (a--);
}

static uchar DSStartConversion (char *dev)
{  char i;

  dispbit=0;
  while(!dispbit)
    if(start_seq) return 10;

  if (DSReset()) return 1;
  if (start_seq) return 10;
  //DSTx(0x55);
  DSTx(0xcc);
  if (start_seq) return 10;
  //for (i=0;i<8;i++)
  //{ DSTx(dev[i]);
  if(start_seq) return 10;
  DSTx (0x44); i=0;
  if(start_seq) return 10;
  while (!DSRx())
  {   if (i++>10000) return 5;
      if(start_seq) return 10;
  }

  if (DSReset()) return 1;
  if(start_seq) return 10;
  DSTx(0xcc);
  if(start_seq) return 10;
  //for (i=0;i<8;i++)
  //{ DSTx(dev[i]); if(start_seq) return 10; }
  DSTx(0xBE);
  if(start_seq) return 10;
  ResetCRC();
  if(start_seq) return 10;
  for (i=0;i<8;i++)
  {  buf[i]=DSRx();
    if(start_seq) return 10;
    CRCupdate(buf[i]);

  }
  buf[8]=DSRx();
  if(start_seq) return 10;
  if (DSReset()) return 1;
  if(start_seq) return 10;
  if (GetCRC()!=buf[8]) return 2;
  return 0;
}

void get_temp(void)
{ int k;

    temp=buf[0];
    temp>>=1;
    if(buf[1]&0x01) temp-=128;

    k=((buf[7]-buf[6])*100);
    k/=buf[7]; k-=25;
    k/=10;  temp*=10; temp+=k;

}

char table(char i)
{
   switch(i)
   {  case 0: return 255-252;
      case 1: return 255-96;
      case 2: return 255-218;
      case 3: return 255-242;
      case 4: return 255-102;
      case 5: return 255-182;
      case 6: return 255-190;
      case 7: return 255-224;
      case 8: return 255-254;
      case 9: return 255-246;
      default: return 255;
   }

}


void setminmax(int *x)
{   char i=0,k;
    int val=0;
    int m; bit ok;
    rdy=0;

    display[1]=display[2]=display[3]=255;
    m=timeout;

    if(x==&tmin)
    {  temp=tmin; display_temp();
    }
    else
    { temp=tmax; display_temp();
    }
    display[2]&=254;

    while(1)
    {
      if ((timeout-m)>100) { clrscr(); return; }
      if (rdy)
      {  rdy=0;
         if(addr==RC5_ADDR&&Toggle!=mToggle)
         {
           if(cmd==0x37||cmd==0x34)
           {   display[1]=display[2]=display[3]=255;
               break;
           }
           if (cmd==0x0c)
           {
              clrscr(); return;
           }


         }
         mToggle=Toggle;
      }

    }


   m=timeout;   mToggle=!Toggle;

   while(1)
   {
     if ((timeout-m)>120) { clrscr(); return; }

    if (rdy)
    {  rdy=0;

       if(addr==RC5_ADDR&&mToggle!=Toggle)
       {
          if(cmd>=0&&cmd<=9) k=cmd;
          else
          if(cmd==0x3b) k=13;
          else
          if(cmd==0x0c) k=27;
          else k=255;

         if (k==27) { clrscr(); return; }

         if(i<3&&k!=13&&k!=27&&k!=255)
         {
           val=val*10+k;
           display[i+1]=table(k); i++;
           if (i==2) display[2]&=0xfe;
         }
         if (i==3&&k==13)
         {
           ok=0;
           if (x==&tmin)
           {
              if (tmax-val>3) ok=1;
           }
           else
           {
             if (val-tmin>3) ok=1;
           }

           if(ok)
           {
            *x=val;
            display_set();
            for (i=1;i<20;i++)
            {
             if (!WriteScratchpad())
             {  display[0]&=0xfe; break; }
                delay(1000);
             }
            }
            else display_error();

           delay(30000);
           delay(30000); delay(30000);
           clrscr();
           return;
         }
         delay(100);

       }
        mToggle=Toggle;

    }

   }

}

void display_auto(void)
{
   da=1;
   display[0]=17;
   display[1]=199;
   display[2]=225;
   display[3]=197;

}

void display_error(void)
{
  display[0]=255; display[1]=97;
  display[2]=display[3]=245;
}



void clrscr(void)
{
  display[0]=display[1]=display[2]=display[3]=255;
}

void display_set(void)
{
   display[0]=255; display[1]=73;
   display[2]=97; display[3]=225;

}


void display_temp(void)
{
   temp+=DELTA;
   if (temp<0)
   { temp=-temp;
     if (temp/100) display[0]&=2;
     else display[1]&=2;
   }
   display[3]=table(temp%10); temp/=10;
   display[2]=table(temp%10); temp/=10;
   if (temp%10) display[1]=table(temp%10);
   display[2]&=254;

}

char WriteScratchpad(void)
{  //char i;

   if (DSReset()) return 1;
   if (start_seq) return 10;
   DSTx(0xcc);
   if (start_seq) return 10;
   //for (i=0;i<8;i++)
   //{ DSTx(dev[i]); if(start_seq) return 10; }
   DSTx(0x4e);
   if (start_seq) return 10;
   if (tmin>0) DSTx(tmin);
   if (tmax<=255) DSTx(tmax);
   if (start_seq) return 10;
   if (DSReset()) return 1;

   if (start_seq) return 10;
   DSTx(0xcc);
   if (start_seq) return 10;
   //for (i=0;i<8;i++)
   //{ DSTx(dev[i]); if(start_seq) return 10; }
   DSTx(0x48);
   if (DSReset()) return 1;
   return 0;

}

char ReadUserBytes(void)
{
  char i;

  if (DSReset()) return 1;
  if (start_seq) return 10;
  DSTx(0xcc);
  if (start_seq) return 10;
  //for (i=0;i<8;i++)
  //{ DSTx(dev[i]); if(start_seq) return 10; }

  DSTx(0xBE);
  if(start_seq) return 10;
  ResetCRC();
  if(start_seq) return 10;
  for (i=0;i<8;i++)
  {  buf[i]=DSRx();
    if(start_seq) return 10;
    CRCupdate(buf[i]);

  }
  buf[8]=DSRx();
  if(start_seq) return 10;
  if (DSReset()) return 2;
  if(start_seq) return 10;
  if (GetCRC()!=buf[8]) return 5;
  tmin=buf[2];
  tmax=buf[3];
  return 0;

}


void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char i,lp;
   bit m_in;

   TL0=49; TH0=251;
   i=0; tmp=0;
   TR1=0; ET1=0; P1=255;

   while(1)
   {
      m_in=in;
      lp=0; TF0=0;
      while(!TF0)
         if(in!=m_in)
         {  lp++; m_in=in;
            if(lp>1) { TR1=1; ET1=1; return; }
         }

      tmp|=in; TF0=0;
      i++;
      if(i==13)
      {
        cmd=tmp&0x003f; addr=(tmp>>6)&0x001f;
        Toggle=(tmp&0x0800)?1:0;
        rdy=1; ET1=1; TR1=1;
        start_seq=1;
        return;
      }
      tmp<<=1;

      while(m_in==in)
       if(TH0>4) {  TR1=1; ET1=1; return; }

      TL0=49; TH0=251;

   }

}

void power_up(void)
{
   display[0]=display[1]=display[2]=display[3]=255-16; delay(30000);
   display[0]=display[1]=display[2]=display[3]=255-2; delay(30000);
   display[0]=display[1]=display[2]=display[3]=255-128; delay(30000);
  // display[0]=display[1]=display[2]=display[3]=255-128;
}