// Radiowy przedluzacz pilotow RC5
// Zbigniew Hajduk 2003-2004

//Przmiennik RF-IR
#include <reg51.h>
typedef unsigned char uchar;

#define MAXBYTE 4

sbit out=P1^7;

sbit led_r=P1^0;
sbit led_g=P1^1;

sbit test=P0^4;
sbit k1=P0^1;


sbit in=P3^2;

void delay(unsigned int);
void crc_update(unsigned char);
void calculate_crc(void);
uchar check_crc(void);

code char dest[8]={0x3a,0x39,0x26,0x0f,0x23,0x29,0x38,0x2a};
code char  src[8]={0x10,0x11,0x35,0x29,0x20,0x2a,0x2b,0x2c};


bit start_bit,start_seq;
bit rdy;
bit p_out,val,half;
bit p_in,c_in;

char cntbit,bitcnt,cntbyte;
uchar CRC,mh,weight;
uchar rec_data[5],buf[3];
unsigned int ircode;
uchar addr,cmd;

void main(void)
{
     char i;
     unsigned int cntl;


    TMOD=0x11; TR0=1; TR1=0;
    IP=1; IE=0x8b;  IT0=1;
    TL1=0; TH1=244;
    start_bit=0; start_seq=0; rdy=0;

    out=0; led_g=led_r=1;

    led_r=0;
    for(i=0;i<5;i++)
    {
       led_g=0; delay(20000); led_g=1; delay(20000);

    }

   led_g=led_r=1;



    while(1)
    {
        if(rdy)
        {  rdy=0;

         if(check_crc())
         {  led_r=0; led_g=1; cntl=50000;

         }
         else
         {
          led_r=1;
          cmd=buf[1]&0x3f; addr=buf[0]&0x07; addr<<=2; addr|=buf[1]>>6;

          //Petla zamiany kodow rozkazow RC5
          //for (i=0;i<8;i++) if(cmd==src[i]) { cmd=dest[i]; break; }
          
          led_g=1;
          
          //Zamiana adresu urzadzenia RC5
          //addr=0x16;
          
          ircode=buf[0]&0x08; ircode|=(addr>>2); ircode|=0x30;
          ircode<<=8; ircode|=(addr<<6);  ircode|=cmd;

          bitcnt=0; TH1=254; EX0=0; ET1=1; TR1=1; p_out=0; half=1;
          while(TR1);   EX0=1;
          cntl=30000;
         }

         }
       cntl--;
       if(!cntl&&(!led_r||!led_g)) led_r=led_g=1;

    }

}

void int_t1(void) interrupt 3 using 1
{
    TL1=132; TH1=252;
    out=p_out;
    if(half)
    {  val=(ircode&0x2000)?1:0;
       if(val) p_out=0; else p_out=1;
       half=0; ircode<<=1; bitcnt++;
       if(bitcnt>14) p_out=0;
    }
    else
    {  if(val) p_out=1; else p_out=0;
       half=1;
       if(bitcnt>14) { p_out=0; TR1=0; EX0=1; }
    }

}




void delay(unsigned int a)
{
   while (a--);
}




void int_t0(void) interrupt 1 using 2
{
   start_bit=start_seq=0; rdy=0;
}

void crc_update(unsigned char x)
{
  unsigned char tmp,f,i;

  f=1;
  for(i=0;i<8;i++)
  {
     tmp=CRC; CRC=(CRC>>1)&0x73;
     CRC|=(((tmp&0x01)^((x&f)?0x01:0))?((tmp^0x18)>>1)|0x80:tmp>>1)&0x8c;
     f<<=1;
  }

}


uchar check_crc(void)
{  CRC=0;

   crc_update(buf[0]);
   crc_update(buf[1]);
   return (buf[2]!=CRC)?1:0;

}

void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char p_th,state;

   TL0=TL1=0; TH0=TH1=0; TR1=1;
   ET1=0;
   tmp=0; cntbit=1; state=0; cntbyte=0;


   while(1)
   {
     p_in=in;
     while(p_in==in) if (TH0>8) return;

      p_th=TH0; TL0=0; TH0=0;
      //  nowy kod
      while(p_in!=in) if(TH0>1) break;
      if(p_in==in) { TL0=TL1; TH0=TH1; continue; }  //if(!TH0)
      else { TL1=TL0; TH1=TH0; }



     //p_th=TH0; TL0=0; TH0=0;

     c_in=in;

     switch(state)
     {
       case 0:
            if(!p_in&&c_in&&p_th>2&&p_th<5) state=1;
            else
            if(!p_in&&c_in&&p_th>4&&p_th<8)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;
       case 1:
            if(p_in&&!c_in&&p_th>2&&p_th<5)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else return;
            break;
       case 2:
            if(p_in&&!c_in&&p_th>4&&p_th<8)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else
            if(p_in&&!c_in&&p_th>2&&p_th<5) state=3;
            else return;
            break;
       case 3:
            if(!p_in&&c_in&&p_th>2&&p_th<5)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;

     }
     if(cntbit>=8) { cntbit=0; rec_data[cntbyte]=tmp; tmp=0; cntbyte++; }
     if (cntbyte>=MAXBYTE)
     {  TR1=0; ET1=1; EX0=1; led_g=0;
        rdy=1;
        buf[0]=rec_data[1]; buf[1]=rec_data[2]; buf[2]=rec_data[3];
       return;
     }

   }

}

