// Radiowy przedluzacz pilotow RC5
// Zbigniew Hajduk 2003-2004

#include <reg51.h>
typedef unsigned char uchar;

#define MAXBYTE 4

sbit DOUT=P1^7;

sbit led_r=P3^0;



sbit   EN=P0^7;
sbit   RW=P0^5;
sbit   RS=P0^6;

sbit in=P3^2;

void delay(unsigned int);
void crc_update(unsigned char);
void calculate_crc(void);


unsigned int irdata;
char cntbyte,cntbit;
bit val;
bit p_in,c_in,rdy,p_out,half;
unsigned int lbyte,hbyte;
char cntb,txb;
uchar CRC,ct,fmask;

uchar send_data[6];

void main(void)
{
    uchar cmd,addr,i;
    char buf[2];
    unsigned int cntl;


    TMOD=0x11; TR0=1; TR1=0;
    IP=2; IE=0x8b;
    TL1=0; TH1=244;
    DOUT=0;

    lbyte=0x0000; hbyte=0x0f0f;
    cntb=0;

    for(i=0;i<5;i++)
    {
       led_r=0; delay(30000); led_r=1; delay(30000);

    }


      while(1)
      {
         if(rdy)
         {
           rdy=0;


          buf[0]=irdata>>8; buf[1]=irdata;
          cmd=buf[1]&0x3f; addr=buf[0]&0x07; addr<<=2; addr|=buf[1]>>6;
          //if(addr!=0) { cntl=30000; continue; }

           send_data[0]=0xca;
           send_data[1]=irdata>>8;
           send_data[2]=irdata;
           calculate_crc();
           
           // inicjowanie transmisji...
           cntbyte=0; EX0=0; half=1; fmask=0x80; TR1=1;
           while(TR1); led_r=1;


         }

       cntl--;
       if(!cntl&&!led_r) led_r=1;

      }

}

/***************************** Kodowanie Manchester *********/

void int_t1(void) interrupt 3 using 1
{
    TL1=132; TH1=252;
    DOUT=p_out;
    if(half)
    {  val=(send_data[cntbyte]&fmask)?1:0;
       if(val) p_out=0; else p_out=1;
       half=0;
       fmask>>=1; if(!fmask) { cntbyte++; fmask=0x80;}
       if(cntbyte>MAXBYTE) p_out=0;
    }
    else
    {  if(val) p_out=1; else p_out=0;
       half=1;
       if(cntbyte>MAXBYTE) { p_out=0; TR1=0; EX0=1; }
    }

}





void delay(unsigned int a)
{
   while (a--);
}


void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char p_th,state;

   TL0=0; TH0=0; tmp=0; cntbit=0; state=0;

   while(1)
   {
     p_in=in;
     while(p_in==in) if (TH0>8) return;
     p_th=TH0; TL0=0; TH0=0; c_in=in;

     switch(state)
     {
       case 0:
            if(!p_in&&c_in&&p_th>2&&p_th<5) state=1;
            else
            if(!p_in&&c_in&&p_th>4&&p_th<8)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;
       case 1:
            if(p_in&&!c_in&&p_th>2&&p_th<5)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else return;
            break;
       case 2:
            if(p_in&&!c_in&&p_th>4&&p_th<8)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else
            if(p_in&&!c_in&&p_th>2&&p_th<5) state=3;
            else return;
            break;
       case 3:
            if(!p_in&&c_in&&p_th>2&&p_th<5)
            { state=2; tmp<<=1; cntbit++; }
            else return;
            break;

     }
     if(cntbit>=13) { led_r=0; irdata=tmp; rdy=1; return; }

   }

}


void int_t0(void) interrupt 1 using 2
{

}

void crc_update(unsigned char x)
{
  unsigned char tmp,f,i;

  f=1;
  for(i=0;i<8;i++)
  {
     tmp=CRC; CRC=(CRC>>1)&0x73;
     CRC|=(((tmp&0x01)^((x&f)?0x01:0))?((tmp^0x18)>>1)|0x80:tmp>>1)&0x8c;
     f<<=1;
  }

}

void calculate_crc(void)
{
   CRC=0;
   crc_update(send_data[1]);
   crc_update(send_data[2]);
   send_data[3]=CRC;

}