// Tester protokolow - wersja 1
// Autor: Zbigniew Hajduk, 2004

#include <reg51.h>
typedef unsigned char uchar;


#define lcd_port P1

sbit   EN=P3^7;
sbit   RW=P1^2;
sbit   RS=P1^3;

sbit in=P3^2;



void BusyCheck(void);
void LCDSendByte(uchar,bit);
void LCDinit (void);
void clrscr (void);
void gotoxy (uchar,uchar);
void LCDputs (char*);
void LCDputch(char);
void delay(unsigned int);
void moveCGRAM (uchar,char,char);
void printdec(int v);
void get_temp(void);
char table(char);



char acnt;


static void printhex(uchar,bit);
void delay(unsigned int);

void int_t0(void);



unsigned long byte;
int *ptr;

bit free,rdy;
uchar CRC;

uchar mh1,ml1,mh2,ml2;

void main(void)
{
        unsigned int i,k;
        TMOD=0x11; TR0=1; TR1=1;
        TL0=0; TH0=0;
        EX0=1; ET0=0; EA=1;
        PT0=1;
        //IE=0x8b;
        IT0=1;



        LCDinit(); clrscr();
        free=rdy=0;

        gotoxy(1,1);
        LCDputs("     Tester ");
        gotoxy(1,2); LCDputs ("  protokolow v1");


        while(1)
        {
           if(rdy)
           {  rdy=0;
              clrscr();
              i=mh1; i<<=8; i|=ml1;
              gotoxy(1,2); printdec(i);
              LCDputs(" ");

              k=mh2; k<<=8; k|=ml2;
              printdec(k);

              gotoxy(1,1); LCDputs("Protokol: ");
              if((i>800&&i<1000)&&(k>790&&k<1000))
              {
                LCDputs("RC5   ");
              }
              else
              if((i>8800&&i<9200)&&(k>4350&&k<4650))
              {
                LCDputs("NEC   ");
              }
              else
              if((i>350&&i<650)&&(k>2300&&k<2700))
              {
                 LCDputs("NOKIA");
              }
              else
              if((i>150&&i<480)&&(k>1500&&k<1950))
              {
                 LCDputs("DENON");
              }
              else
              if((i>2250&&i<2600)&&(k>420&&k<780))
              {
                 LCDputs("SONY ");
              }
              else
              LCDputs("???");

           }

        }

}

/************************ Obsluga LCD ***********************/
void BusyCheck(void)
{  uchar tmp;
   lcd_port&=0x0f; lcd_port|=0xf0;
  do
  {
   RS=0; RW=1;
   EN=1; EN=1; EN=1; tmp=lcd_port;
   EN=0; tmp&=0xf0; EN=1;
   //tmp<<=4;
   //tmp|=(lcd_port&0x0f);
   EN=0;
   } while (tmp&128);
}

void LCDSendByte (uchar cm,bit what)
{
  ET0=0;
  BusyCheck();
  lcd_port&=0x0f;
  lcd_port|=(((cm>>4)&0x0f)<<4);
  RW=0; RS=what;
  EN=1; EN=1; EN=1; EN=0;
  lcd_port&=0x0f;
  lcd_port|=((cm&0x0f)<<4);
  EN=1; EN=1; EN=1; EN=0;
  ET0=1;
}

void LCDinit (void)
{
  ET0=0;
  RW=0; RS=0;
  lcd_port&=0x0f; lcd_port|=0x30;
  EN=1; EN=1; EN=1; EN=0;
  delay (20);
  lcd_port&=0x0f; lcd_port|=0x30;
  EN=1; EN=1; EN=1; EN=0;
  delay(10);
  lcd_port&=0x0f; lcd_port|=0x30;
  EN=1; EN=1; EN=1; EN=0;
  delay(10);
  lcd_port&=0x0f; lcd_port|=0x20;
  EN=1; EN=1; EN=1; EN=0;
  delay(10);
  LCDSendByte (0x28,0);
  LCDSendByte (0x0c,0);
  LCDSendByte (0x01,0);
  LCDSendByte (0x06,0);
  LCDSendByte (0x80,0);
  ET0=1;
}

void clrscr (void)
{  LCDSendByte(0x01,0);
}

void gotoxy (uchar x,uchar y)
{ LCDSendByte(((y==1)?0x80:0xc0)+x-1,0);
}

void LCDputs (char *p)
{
  while (*p)
  {  LCDSendByte(*p++,1);
  }
}

void LCDputch(char c)
{
  LCDSendByte(c,1);
}

/***************************** LCD *************************************/



  void int_t0(void) interrupt 1 using 1
  {


    free=1;



  }


void int_t1(void) interrupt 3 using 2
{
   TH1=0xf6; TL1=0x3b;

}




static void printhex(uchar i,bit f)
{
    char *tohex="0123456789ABCDEF";

    if (!f) LCDputch(tohex[i>>4]);
    LCDputch(tohex[i&0x0f]);
}

void delay(unsigned int a)
{
   while (a--);
}



void printdec(int v)
{  char t[5]; int i; bit flag=1;

   if (v==0)  LCDputch(48);
   else
   {
    for (i=0;i<5;i++)
    {  t[i]= v%10;
        v/=10;
    }
   for (i=4;i>=0;i--)
   {
     if (t[i]) flag=0;
     if (!flag) LCDputch (t[i]+48);
   }
  }
}



void int_ext0(void) interrupt 0 using 1
{
   //mh=TH0;
   TL0=0; TH0=0;    EX0=0;

   while(!in)
   {  if(TH0==255) { free=0; EX0=1; return; }
   }
   ml1=TL0; TL0=0; mh1=TH0; TH0=0;
   while(in)
   {
      if(TH0==255) { free=0; EX0=1; return; }
   }
   ml2=TL0; TL0=0; mh2=TH0; TH0=0;
   rdy=1;
   while(1)
   {
     if(!in) { TL0=0; TH0=0; }
     if(TH0==255) { free=0; IE0=0; EX0=1; return; }

   }

}

