//Tester protokow
//(c) Zbigniew Hajduk zhajduk@prz-rzeszow.pl

#include <reg51.h>
typedef unsigned char uchar;

#define lcd_port P1

sbit   EN=P3^7;
sbit   RW=P1^2;
sbit   RS=P1^3;


sbit in=P3^2;


void BusyCheck(void);
void LCDSendByte(uchar,bit);
void LCDinit (void);
void clrscr (void);
void gotoxy (uchar,uchar);
void LCDputs (char*);
void LCDputch(char);
void delay(unsigned int);


static void printhex(uchar i,bit f);
uchar reverse1(uchar,uchar);
unsigned int reverse2(unsigned int);


char cntbit;
bit p_in,c_in,rdy;
int cnt;
char cmd,addr,mh;
bit err_display;
char err;
char protocol,c1,a1;
bit Toggle;
unsigned int irdata1,irdata2;


void main(void)
{  char i;


      TMOD=0x11; TR0=1; TR1=1;
      TH1=0xfd;
      PCON=0x00;
      SCON=0x40;
      TL0=0; TH0=0;
      IP=1;  IT0=1;
      EX0=1; ET0=1; EA=1;


     err=0;  err_display=0;

     LCDinit(); clrscr();
     LCDputs("    Tester");
     gotoxy(1,2);  LCDputs("  protokolow");

     while(1)
     {

       if(rdy)
       {
         rdy=0; err_display=0;
         gotoxy(1,1);
         switch(protocol)
         { case 3: LCDputs("NEC   ");
                   irdata1=reverse2(irdata1); irdata2=reverse2(irdata2);
                   addr=irdata2>>8; cmd=irdata1>>8;
                   a1=irdata2; c1=irdata1;
                   printhex(irdata2>>8,0); printhex(irdata2,0);
                   printhex(irdata1>>8,0); printhex(irdata1,0);
                   break;
           case 2: LCDputs("SONY  ");
                   printhex(irdata1>>8,0);
                   printhex(irdata1,0); LCDputs("     ");
                   addr=reverse1(addr,5); cmd=reverse1(cmd,7);
                   break;

           case 1: LCDputs("RC5   ");
                   printhex(irdata1>>8,0);
                   printhex(irdata1,0);  LCDputs("     ");
                   break;

         }

         gotoxy(1,2); LCDputs("A=");printhex(addr,0); LCDputs(" C=");
         printhex(cmd,0);
         if(protocol==1)
         {   LCDputs(" T=");printhex(Toggle,0);
         }
         LCDputs("   ");
         if(protocol!=1) LCDputs("   ");

         }

     }

}  /*End of main */



void delay(unsigned int a)
{
   while (a--);
}

/************************ Obsluga LCD ***********************/
void BusyCheck(void)
{  uchar tmp;
   lcd_port&=0x0f; lcd_port|=0xf0;
  do
  {
   RS=0; RW=1;
   EN=1; EN=1; EN=1; tmp=lcd_port;
   EN=0; tmp&=0xf0; EN=1;
   //tmp<<=4;
   //tmp|=(lcd_port&0x0f);
   EN=0;
   } while (tmp&128);
}

void LCDSendByte (uchar cm,bit what)
{
  ET0=0;
  BusyCheck();
  lcd_port&=0x0f;
  lcd_port|=(((cm>>4)&0x0f)<<4);
  RW=0; RS=what;
  EN=1; EN=1; EN=1; EN=0;
  lcd_port&=0x0f;
  lcd_port|=((cm&0x0f)<<4);
  EN=1; EN=1; EN=1; EN=0;
  ET0=1;
}

void LCDinit (void)
{
  ET0=0;
  RW=0; RS=0;
  lcd_port&=0x0f; lcd_port|=0x30;
  EN=1; EN=1; EN=1; EN=0;
  delay (20);
  lcd_port&=0x0f; lcd_port|=0x30;
  EN=1; EN=1; EN=1; EN=0;
  delay(10);
  lcd_port&=0x0f; lcd_port|=0x30;
  EN=1; EN=1; EN=1; EN=0;
  delay(10);
  lcd_port&=0x0f; lcd_port|=0x20;
  EN=1; EN=1; EN=1; EN=0;
  delay(10);
  LCDSendByte (0x28,0);
  LCDSendByte (0x0c,0); /* 0x0e - kursor widoczny */
  LCDSendByte (0x01,0);
  LCDSendByte (0x06,0);
  LCDSendByte (0x80,0);
  ET0=1;
}

void clrscr (void)
{  LCDSendByte(0x01,0);
}

void gotoxy (uchar x,uchar y)
{ LCDSendByte(((y==1)?0x80:0xc0)+x-1,0);
}

void LCDputs (char *p)
{
  while (*p)
  {  LCDSendByte(*p++,1);
  }
}

void LCDputch(char c)
{
  LCDSendByte(c,1);
}

/***************************** LCD *************************************/



static void printhex(uchar i,bit f)
{
    char *tohex="0123456789ABCDEF";

    if (!f) LCDputch(tohex[i>>4]);
    LCDputch(tohex[i&0x0f]);
}



void int_t0(void) interrupt 1 using 2
{
   //err=0;
   err_display=0;
}

void int_t1(void) interrupt 3 using 2
{


}

void int_ext0(void) interrupt 0 using 2
{
   unsigned long int tmp;
   int tmp1;
   unsigned char p_th,state;
   char i;
   bit m_in,p_in,c_in;


   TH0=0; TL0=0;

   while (!in)
    if(TH0>47) return; //t>12ms

   p_th=TH0;
   TH0=0; TL0=0;


  tmp=0;  tmp1=0;

  if(p_th>34)
  {
    while (in)
    if(TH0>24) return; //t>6.1ms
   if(TH0<15) return; //t<3.8ms
   i=0;
   while(1)
   {   TH0=0; TL0=0;
       m_in=in;
       while(1)
       {  if(TH0>12) return; //t>3ms
          if(m_in!=in)
            if(m_in&&!in) break; //zbocze opadajace
            else
            m_in=in;
       }
       if(TH0>=7) tmp|=1;
       i++;
       if(i>31)
       { irdata1=tmp; irdata2=tmp>>16;
         protocol=3;
          rdy=1;
          return;
       }
       tmp<<=1;
   }
  } //koniec dekodowania NECa
  else
  if(p_th>=8&&p_th<=10)
  {
       while (in)
        if(TH0>3) return; //t>1ms

       i=0;
       while(1)
       {   TH0=0; TL0=0;
           while(!in)
            if(TH0>11) return; //t>2.8ms
           if(TH0>3) tmp1|=1;
           TH0=0; TL0=0;
           i++;
           if(i==12)
           { irdata1=tmp1&0x0fff;
             addr=tmp1&0x1f; cmd=tmp1>>5;
             protocol=2;
             rdy=1; return;
           }
           tmp1<<=1;
           while(in)
            if(TH0>3) return; //t>2.8ms

       }
  }// koniec SONY
  else
  {      state=1; cntbit=0;
         while(1)
         {
           p_in=in;
           while(p_in==in) if (TH0>8) return;
           p_th=TH0; TL0=0; TH0=0; c_in=in;

           switch(state)
           {
             case 0:
                  if(!p_in&&c_in&&p_th>2&&p_th<5) state=1;
                  else
                  if(!p_in&&c_in&&p_th>4&&p_th<8)
                  { state=2; tmp1<<=1; cntbit++; }
                  else return;
                  break;
             case 1:
                  if(p_in&&!c_in&&p_th>2&&p_th<5)
                  { state=0; tmp1<<=1; tmp1|=1; cntbit++; }
                  else return;
                  break;
             case 2:
                  if(p_in&&!c_in&&p_th>4&&p_th<8)
                  { state=0; tmp1<<=1; tmp1|=1; cntbit++; }
                  else
                  if(p_in&&!c_in&&p_th>2&&p_th<5) state=3;
                  else return;
                  break;
             case 3:
                  if(!p_in&&c_in&&p_th>2&&p_th<5)
                  { state=2; tmp1<<=1; cntbit++; }
                  else return;
                  break;

           }
           if(cntbit>=13)
           { irdata1=tmp1; irdata1|=0x2000;
             cmd=tmp1&0x003f; addr=(tmp1>>6)&0x001f;
             Toggle=(tmp1&0x0800)?1:0;
             protocol=1;
             rdy=1; return;
           }

         }
  }//koniec RC5

}

uchar reverse1(uchar x,uchar b)
{  char i,w1,f1;

   w1=0;
   f1=1;
   for (i=0;i<b;i++)
   {  w1<<=1;
      w1|=(x&f1)?1:0; f1<<=1;
   }

   return w1;

}


static unsigned int reverse2(unsigned int x)
{  code char xchg[16]={0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15};
   uchar t,w1,w2;


   t=x; w1=xchg[t&0x0f]; w1<<=4; w1|=xchg[t>>4];
   t=x>>8; w2=xchg[t&0x0f]; w2<<=4; w2|=xchg[t>>4];
   x=w2; x<<=8; x|=w1;
   return x;

}