//Wskaznik adresu i numeru polecenia RC5
//Autor: Zbigniew Hajduk, 2004
#include <reg51.h>
typedef unsigned char uchar;

sbit A1=P3^0;
sbit A2=P3^1;
sbit A3=P3^4;
sbit A4=P3^5;
sbit in=P3^2;

void clrscr (void);
char table(char);
void display_rc5(void);
void clrscr(void);
void display_error(void);
static void printhex(void);
void delay(unsigned int);
void int_t0(void);
uchar buf[10];

char acnt;
char mh,ml;
char err_cntr,addr,cmd;
unsigned irdata;
bit Toggle,rdy,da;
char display[4];
int temp,dxx;
char dcnt;
volatile int timeout;

void main(void)
{


        TMOD=0x11; TR0=1; TR1=1;
        TL0=0; TH0=0;
        IP=1; IE=0x8b;  IT0=1;



        A1=A2=A3=A4=1;
        ET1=0; P1=255;
        clrscr();
        ET1=1; EA=1;
        da=0; timeout=0;

         while(1)
         {

            if(err_cntr>12)
            {
               timeout=0; da=1;
               display_error();
            }

            if(timeout>15&&da) { da=0; dcnt=6; }

            if(rdy)
            {
               rdy=0;
               timeout=0; da=1;
               cmd=irdata&0x003f; addr=(irdata>>6)&0x001f;
               Toggle=(irdata&0x0800)?1:0;
               printhex();
               if(Toggle) display[1]&=0xfe;
               if(!(irdata&0x1000)) display[0]&=0xfe;

            }
         }

}


void int_t0(void) interrupt 1 using 2
{

  ET1=1; TR1=1;
  err_cntr=0;

}


void int_t1(void) interrupt 3 using 2
{
   TH1=0xf6; TL1=0x3b;
   P1=255;
   switch(acnt)
   { case 0: A1=0; A2=1; A3=1; A4=1;
             P1=display[acnt]; acnt=1; break;
     case 1: A1=1; A2=0; A3=1; A4=1;
             P1=display[acnt]; acnt=2; break;
     case 2: A1=1; A2=1; A3=0; A4=1;
             P1=display[acnt]; acnt=3; break;
     case 3: A1=1; A2=1; A3=1; A4=0;
             P1=display[acnt]; acnt=0; break;
   }

   dxx++;

   if(dxx>150)
   { dxx=0;
      timeout++;
      if (da) return;
      switch(dcnt)
      {
       case 0: display[0]=display[1]=display[2]=255; display[3]=245; dcnt=1; break;
       case 1: display[0]=display[1]=255; display[2]=245; display[3]=229; dcnt=2; break;
       case 2: display[0]=255; display[1]=245; display[2]=229; display[3]=73; dcnt=3; break;
       case 3: display[0]=245; display[1]=229; display[2]=73; display[3]=255; dcnt=4; break;
       case 4: display[0]=229; display[1]=73; display[2]=255; display[3]=255; dcnt=5; break;
       case 5: display[0]=73; display[1]=255; display[2]=255; display[3]=255; dcnt=6; break;
       case 6: display[0]=255; display[1]=255; display[2]=255; display[3]=255; dcnt=0; break;
      }

   }

}


void delay(unsigned int a)
{
   while (a--);
}


char table(char i)
{
   switch(i)
   {  case 0: return 255-252;
      case 1: return 255-96;
      case 2: return 255-218;
      case 3: return 255-242;
      case 4: return 255-102;
      case 5: return 255-182;
      case 6: return 255-190;
      case 7: return 255-224;
      case 8: return 255-254;
      case 9: return 255-246;
      default: return 255;
   }

}

void display_error(void)
{

  display[0]=255; display[1]=97;
  display[2]=display[3]=245;
}

void clrscr(void)
{
  display[0]=display[1]=display[2]=display[3]=255;
}

void display_rc5(void)
{
 display[0]=253; display[1]=245;
 display[2]=229; display[3]=255-182;
}

static void printhex(void)
{
    code char tohex[16]={3,159,37,13,153,73,65,31,1,9,17,193,229,133,97,113};
     display[0]=tohex[addr>>4]; display[1]=tohex[addr&0x0f];
    display[2]=tohex[cmd>>4]; display[3]=tohex[cmd&0x0f];

}

void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char i,lp;
   bit m_in;

   TL0=49; TH0=251;
   i=0; tmp=0;
   TR1=0; ET1=0; P1=255;

   while(1)
   {
      m_in=in;
      lp=0; TF0=0;
      while(!TF0)
         if(in!=m_in)
         {  lp++; m_in=in;
            if(lp>1) { err_cntr++; return; }
         }

      tmp|=in; TF0=0;
      i++;
      if(i==13)
      { irdata=tmp; err_cntr=0;
        rdy=1; ET1=1; TR1=1;
        return;
      }
      tmp<<=1;

      while(m_in==in)
       if(TH0>4) { err_cntr++; return; }

      TL0=49; TH0=251;

   }

}

