//Zdalnie sterowany wcznik
//Zbigniew Hajduk, 2004

#include <reg51.h>
typedef unsigned char uchar;



sbit SCL=P3^0;
sbit SDA=P3^1;
sbit in=P3^2;

sbit LED1=P1^6;
sbit LED2=P1^4;
sbit LED3=P1^1;
sbit LED4=P1^0;

sbit RELAY1=P1^7;
sbit RELAY2=P1^5;
sbit RELAY3=P1^3;
sbit RELAY4=P1^2;

sbit LED=P3^4;
sbit SW=P3^5;


void delay(unsigned int);
void delay50(void);
void get_ack(void);
uchar put_byte(unsigned char);
void put_scl(void);
uchar i2c_trx(uchar,uchar,uchar,char *);
uchar i2c_rx (uchar,uchar,uchar,char *);
uchar get_byte(uchar);
void i2c_start(void);

void normal(void);


static void printhex(uchar i,bit f);

char cntbit;
bit p_in,c_in,rdy;
volatile int cnt;

uchar buf[1];
uchar mem[16];

bit pgm,Toggle,mToggle,flash,flash1;
char cmd,addr;
char pcnt,tcnt;
bit sw,msw,sw1,ac1;
bit p1,p2,p3,p4;


void main(void)
{
   bit memsw,ac;
   char laddr,lcmd;
   char i;


      TMOD=0x11; TR0=1; TR1=1;
      TL0=0; TH0=0;
      IP=1; IE=0x8b;  IT0=1;

      SDA=1; SCL=0;
      LED1=LED2=LED3=LED4=1;
      RELAY1=RELAY2=RELAY3=RELAY4=0;
      LED=SW=1;
      pgm=0;   flash=0; flash1=0;
      tcnt=0;  sw1=0; ac=0; ac1=0;
      p1=p2=p3=p4;



     if(!i2c_rx(0xa0,0,12,mem))
     { LED=0;
       LED1=0; delay(40000); LED1=1;
       LED2=0; delay(40000); LED2=1;
       LED3=0; delay(40000); LED3=1;
       LED4=0; delay(40000); LED4=1;
       LED=1;
     }
     else
     {
       LED1=LED2=LED3=LED4=0;
       delay(50000);
       LED1=LED2=LED3=LED4=1;
     }


     while(1)
     {


        if(!SW&&memsw)  cnt=0;
        memsw=SW;

        if(!SW&&!pgm)
        {
            if(cnt>220)
            { LED=0; pgm=1; pcnt=0; flash=1;
              cnt=0; sw=0;
            }
        }

        if(!SW&&pgm&&!memsw)
        {
            if(cnt>220)
            { LED=1; pgm=0; pcnt=0; flash=0; flash1=0;
              cnt=0; sw=0;
              LED1=LED2=LED3=LED4=0;
              delay(55000);
              LED1=LED2=LED3=LED4=1;

            }
        }


        if(pgm&&!flash1)
        {
           if(sw)
           {  sw=0;
              LED1=LED2=LED3=LED4=1;

              if(pcnt<3) pcnt++;
              else pcnt=0;

              //while(!SW);
           }

        }



        if(pgm&&flash1)
        {
           if(sw)
           {   sw=0;
               LED=0;
               flash1=0;

                mem[pcnt*2]=addr;
                mem[pcnt*2+1]=cmd;


                if(!i2c_trx(0xa0,0,8,mem))
                {
                 LED=1;
                 LED1=LED2=LED3=LED4=0;
                 delay(55000);
                 LED1=LED2=LED3=LED4=1; LED=0;
                 delay(20000); LED=1;
                 delay(20000); LED=0;

                }
                else
                {
                 LED=1;
                 for(i=0;i<6;i++)
                 {
                   LED1=LED2=LED3=LED4=0;
                   delay(20000);
                   LED1=LED2=LED3=LED4=1;
                   delay(20000);

                 }

               }
               flash=1; ac=0;
           }
            else
            if(cnt>600)
            { ac=0; flash=1; flash1=0; LED=0;
            }
        }


       if(rdy)
       {
         rdy=0;
         if(Toggle==mToggle) continue;

          if(pgm)
          {
             if(flash1)
             {  ac=0; flash=1;
                flash1=0; LED=0;
                mToggle=Toggle;
                continue;
             }

             if(flash&&!ac)
             {
                flash=0; flash1=1;
                switch(pcnt)
                {  case 0: LED1=0; break;
                   case 1: LED2=0; break;
                   case 2: LED3=0; break;
                   case 3: LED4=0; break;
                }

                ac=1; cnt=0;
             }

          }

         if(!pgm)
         {

             pcnt=255;
             for(i=0;i<4;i++)
             {
               if(mem[2*i]==addr&&mem[2*i+1]==cmd)
               { pcnt=i; break; }
             }
             LED=1;
             if(cnt==254)
             {
              mToggle=Toggle;
              continue;
             }


                switch(pcnt)
                {
                   case 0: p1=!p1;
                           RELAY1=(p1)?1:0;
                           if(p1) LED1=0;
                           else LED1=1;
                           break;

                   case 1: p2=!p2;
                           RELAY2=(p2)?1:0;
                           if(p2) LED2=0;
                           else LED2=1;
                           break;

                    case 2: p3=!p3;
                            RELAY3=(p3)?1:0;
                            if(p3) LED3=0;
                            else LED3=1; break;

                    case 3: p4=!p4;
                            RELAY4=(p4)?1:0;
                            if(p4) LED4=0;
                            else LED4=1; break;

                }


         }




         mToggle=Toggle;

       }

     }



}  /*End of main */



void delay(unsigned int a)
{
   while (a--);
}




void int_ext0(void) interrupt 0 using 2
{
   unsigned int tmp;
   char p_th,state;

   TL0=0; TH0=0; tmp=0; cntbit=0; state=0;
   if(!pgm) LED=0;

   while(1)
   {
     p_in=in;
     while(p_in==in) if (TH0>8) { if(!pgm) LED=1; return; }
     p_th=TH0; TL0=0; TH0=0; c_in=in;

     switch(state)
     {
       case 0:
            if(!p_in&&c_in&&p_th>2&&p_th<5) state=1;
            else
            if(!p_in&&c_in&&p_th>4&&p_th<8)
            { state=2; tmp<<=1; cntbit++; }
            else { if(!pgm) LED=1; return;  }
            break;
       case 1:
            if(p_in&&!c_in&&p_th>2&&p_th<5)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else { if(!pgm) LED=1; return; }
            break;
       case 2:
            if(p_in&&!c_in&&p_th>4&&p_th<8)
            { state=0; tmp<<=1; tmp|=1; cntbit++; }
            else
            if(p_in&&!c_in&&p_th>2&&p_th<5) state=3;
            else {  if(!pgm) LED=1 ;return;  }
            break;
       case 3:
            if(!p_in&&c_in&&p_th>2&&p_th<5)
            { state=2; tmp<<=1; cntbit++; }
            else { if(!pgm) LED=1; return; }
            break;

     }
     if(cntbit>=13)
     {
     cmd=tmp&0x003f; addr=(tmp>>6)&0x001f;
     Toggle=(tmp&0x0800)?1:0;
     rdy=1; return;
     }

   }

}


void int_t0(void) interrupt 1 using 2
{

}


/********************** IIC protocol **********************/
// Written by Z.H.

void delay50(void)
{  char k;
 k=0; k++;
}

void get_ack(void)
{ SDA=1; delay50(); SCL=1; delay50(); delay50();
}

uchar put_byte(unsigned char b)
{ unsigned char i;
 for (i=0;i<8;i++)
 {  SDA=(b&128)?1:0;
     delay50(); put_scl();
    b<<=1;
 }
  get_ack();
  if (SDA) {  SCL=0; delay50(); delay50(); SDA=0;
              delay50(); SDA=1;  return 1; }
 /* while (!SCL); */
  SCL=0;
  delay50();
  return 0;
}

void put_scl(void)
{  SCL=1; while (!SCL); delay50(); delay50(); SCL=0; delay50();
}

uchar i2c_trx(uchar SLA,uchar adr,uchar n,char *p)
{  i2c_start();
   SLA=SLA&0xfe;
   if (put_byte(SLA)) return 1;
   if (put_byte(adr)) return 1;
   while (n--)
   {  if (put_byte(*p++)) return 1;
   }
   SDA=0;
   delay50(); delay50();
   SCL=1; delay50(); delay50(); SDA=1;
   n=20; while (n--) delay50();
   return 0;
}

uchar get_byte(uchar n)
{  char i;  uchar tmp=0;

 SDA=1;
 for (i=0;i<8;i++)
 { delay50(); SCL=1;
/*  while (!SCL); */
  delay50(); delay50();
  tmp<<=1; tmp|=SDA;
  SCL=0; delay50();
 }
 SDA=(n)?0:1; delay50(); SCL=1; delay50(); delay50();
 SCL=0;  SDA=1;  delay50();
 return tmp;
}

void i2c_start(void)
{
  SDA=1; SCL=1; delay50();
  SDA=0; delay50(); delay50();
  SCL=0; delay50();
}

uchar i2c_rx (uchar SLA,uchar adr,uchar n,char *p)
{
  i2c_start();
  SLA=SLA&0xfe;
  if (put_byte(SLA)) return 1;
  if (put_byte(adr)) return 1;
  SDA=1; delay50(); SCL=1;
  delay50(); SDA=0; delay50(); SCL=0; delay50();
  SLA|=1;  if (put_byte(SLA)) return 1;
  while (n--)
  {  *p++=get_byte(n);
  }
  SDA=0;
  delay50();
  SCL=1; delay50(); SDA=1;
  //n=20;  while (n--) delay50();
  return 0;
}
/************* End of software emulated IIC protocol *******************/

void int_t1(void) interrupt 3 using 2
{
   TH1=216; TL1=241; //10ms
   cnt++;
   tcnt++;


   if(!SW&&msw) sw=1;
   msw=SW;


   if(tcnt>30)
   {  tcnt=0;
      if(flash)
      {
         switch(pcnt)
         {  case 0: LED1=!LED1; break;
            case 1: LED2=!LED2; break;
            case 2: LED3=!LED3; break;
            case 3: LED4=!LED4; break;

         }

      }

      if(flash1) LED=!LED;
   }
}


void normal(void)
{
  flash=0; ac1=0;

  if(p4) LED4=0;
  else LED4=1;
  if(p3) LED3=0;
  else LED3=1;
  if(p2) LED2=0;
  else LED2=1;
  if(p1) LED1=0;
  else LED1=1;

}

